(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs')) :
    typeof define === 'function' && define.amd ? define('@dev-stream/angular-utils', ['exports', 'rxjs'], factory) :
    (global = global || self, factory((global['dev-stream'] = global['dev-stream'] || {}, global['dev-stream']['angular-utils'] = {}), global.rxjs));
}(this, (function (exports, rxjs) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @record
     */
    function IActivatedRouteInjected() { }
    if (false) {
        /** @type {?} */
        IActivatedRouteInjected.prototype.route;
    }
    /**
     * @template T
     * @param {?=} dataKey
     * @param {?=} routeKey
     * @param {?=} ctr
     * @return {?}
     */
    function FromRouteData(dataKey, routeKey, ctr) {
        if (dataKey === void 0) { dataKey = null; }
        if (routeKey === void 0) { routeKey = 'route'; }
        if (ctr === void 0) { ctr = null; }
        return (/**
         * @param {?} target
         * @param {?} propertyName
         * @return {?}
         */
        function (target, propertyName) {
            if (dataKey == null) {
                dataKey = propertyName;
            }
            Object.defineProperty(target, propertyName, {
                configurable: true,
                get: /**
                 * @return {?}
                 */
                function () {
                    /** @type {?} */
                    var route = (/** @type {?} */ (this[routeKey]));
                    if (route == null) {
                        console.error("Property " + routeKey + " is not \"ActivatedRoute\". Maybe you forgot to inject it");
                    }
                    /** @type {?} */
                    var data = route.snapshot.data;
                    if (data != null && dataKey in data) {
                        if (ctr != null) {
                            return new ctr(data[dataKey]);
                        }
                        else {
                            return data[dataKey];
                        }
                    }
                    else {
                        return null;
                    }
                },
                set: /**
                 * @return {?}
                 */
                function () {
                    throw new Error('Property is readonly');
                }
            });
        });
    }
    /**
     * @template T
     * @param {?=} property
     * @param {?=} routeKey
     * @param {?=} ctr
     * @return {?}
     */
    function MapRouteParams(property, routeKey, ctr) {
        if (property === void 0) { property = null; }
        if (routeKey === void 0) { routeKey = 'route'; }
        if (ctr === void 0) { ctr = null; }
        return MapParams((/**
         * @param {?} route
         * @return {?}
         */
        function (route) { return route.snapshot.paramMap; }), property, routeKey, ctr);
    }
    /**
     * @template T
     * @param {?=} property
     * @param {?=} routeKey
     * @param {?=} ctr
     * @return {?}
     */
    function MapQueryParams(property, routeKey, ctr) {
        if (property === void 0) { property = null; }
        if (routeKey === void 0) { routeKey = 'route'; }
        if (ctr === void 0) { ctr = null; }
        return MapParams((/**
         * @param {?} route
         * @return {?}
         */
        function (route) { return route.snapshot.queryParamMap; }), property, routeKey, ctr);
    }
    /**
     * @template T
     * @param {?} getParamMap
     * @param {?=} property
     * @param {?=} routeKey
     * @param {?=} ctr
     * @return {?}
     */
    function MapParams(getParamMap, property, routeKey, ctr) {
        if (property === void 0) { property = null; }
        if (routeKey === void 0) { routeKey = 'route'; }
        if (ctr === void 0) { ctr = null; }
        return (/**
         * @param {?} target
         * @param {?} propertyName
         * @return {?}
         */
        function (target, propertyName) {
            Object.defineProperty(target, propertyName, {
                configurable: true,
                get: /**
                 * @return {?}
                 */
                function () {
                    /** @type {?} */
                    var route = (/** @type {?} */ (this[routeKey]));
                    if (route == null) {
                        console.error("Property " + routeKey + " is not \"ActivatedRoute\". Maybe you forgot to inject it");
                    }
                    /** @type {?} */
                    var paramMap = getParamMap(route);
                    if (paramMap != null) {
                        if (property == null) {
                            /** @type {?} */
                            var obj = paramMap.keys.reduce((/**
                             * @param {?} prev
                             * @param {?} key
                             * @return {?}
                             */
                            function (prev, key) {
                                var _a;
                                return __assign({}, prev, (_a = {}, _a[key] = paramMap.get(key), _a));
                            }), {});
                            if (ctr == null) {
                                return obj;
                            }
                            else if (ctr === 'Array') {
                                throw new Error('Field "property" should be defined to take array from params');
                            }
                            else {
                                return new ctr(obj);
                            }
                        }
                        if (!paramMap.has(property) == null) {
                            return null;
                        }
                        /** @type {?} */
                        var value = paramMap.get(property);
                        if (ctr == null) {
                            return value;
                        }
                        else if (ctr === 'Array') {
                            return JSON.parse("[" + value + "]");
                        }
                        else {
                            return new ctr((/** @type {?} */ (value)));
                        }
                    }
                },
                set: /**
                 * @return {?}
                 */
                function () {
                    throw new Error('Property is readonly');
                }
            });
        });
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var mapObjectToAttributes = (/**
     * @param {?} obj
     * @return {?}
     */
    function (obj) {
        /** @type {?} */
        var attributes = Object.keys(obj).map((/**
         * @param {?} attr
         * @return {?}
         */
        function (attr) { return attr + "=\"" + obj[attr] + "\""; }));
        return attributes.join(' ');
    });
    var ɵ0 = mapObjectToAttributes;
    /** @type {?} */
    var mapObjectToStyles = (/**
     * @param {?} obj
     * @return {?}
     */
    function (obj) {
        /** @type {?} */
        var styles = Object.keys(obj).map((/**
         * @param {?} style
         * @return {?}
         */
        function (style) { return style + ": " + obj[style]; }));
        return "style=\"" + styles.join('; ') + "\"";
    });
    var ɵ1 = mapObjectToStyles;
    /** @type {?} */
    var build = (/**
     * @param {?} template
     * @param {?=} styles
     * @param {?=} attrs
     * @param {?=} classes
     * @return {?}
     */
    function (template, styles, attrs, classes) {
        if (styles === void 0) { styles = {}; }
        if (attrs === void 0) { attrs = {}; }
        if (classes === void 0) { classes = []; }
        return "<div class=\"" + classes.join(' ') + "\" " + mapObjectToStyles(styles) + " " + mapObjectToAttributes(attrs) + ">" + template + "</div>";
    });
    var ɵ2 = build;
    /**
     * @record
     */
    function IFlexParam() { }
    if (false) {
        /** @type {?|undefined} */
        IFlexParam.prototype.flex;
        /** @type {?|undefined} */
        IFlexParam.prototype.direction;
        /** @type {?|undefined} */
        IFlexParam.prototype.alignment;
        /** @type {?|undefined} */
        IFlexParam.prototype.justification;
        /** @type {?|undefined} */
        IFlexParam.prototype.fix;
    }
    var Wrapper = /** @class */ (function () {
        function Wrapper(_template) {
            var _this = this;
            this._template = _template;
            this._classes = [];
            this._flexDefaults = { flex: true, alignment: 'stretch', justification: 'flex-start', direction: 'column', fix: true };
            this.withStyles = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} styles
             * @return {THIS}
             */
            function (styles) {
                _this._stylesObj = __assign({}, _this._stylesObj, styles);
                return _this;
            });
            this.withAttrs = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} attrs
             * @return {THIS}
             */
            function (attrs) {
                _this._attrsObj = __assign({}, _this._attrsObj, attrs);
                return _this;
            });
            this.withWidth = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} width
             * @return {THIS}
             */
            function (width) {
                _this._stylesObj = __assign({}, _this._stylesObj, { width: width });
                return _this;
            });
            this.withHeight = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} height
             * @return {THIS}
             */
            function (height) {
                _this._stylesObj = __assign({}, _this._stylesObj, { height: height });
                return _this;
            });
            this.withMaxWidth = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} width
             * @return {THIS}
             */
            function (width) {
                _this._stylesObj = __assign({}, _this._stylesObj, { 'max-width': width });
                return _this;
            });
            this.withMaxHeight = (/**
             * @template THIS
             * @this {THIS}
             * @param {?} height
             * @return {THIS}
             */
            function (height) {
                _this._stylesObj = __assign({}, _this._stylesObj, { 'max-height': height });
                return _this;
            });
            this.withFlex = (/**
             * @template THIS
             * @this {THIS}
             * @param {?=} params
             * @return {THIS}
             */
            function (params) {
                if (params === void 0) { params = _this._flexDefaults; }
                _this._attrsObj = __assign({}, _this._attrsObj, _this._flexDefaults, params);
                return _this;
            });
        }
        /**
         * @template THIS
         * @this {THIS}
         * @param {?} className
         * @return {THIS}
         */
        Wrapper.prototype.withClass = /**
         * @template THIS
         * @this {THIS}
         * @param {?} className
         * @return {THIS}
         */
        function (className) {
            (/** @type {?} */ (this))._classes.push(className);
            return (/** @type {?} */ (this));
        };
        /**
         * @return {?}
         */
        Wrapper.prototype.build = /**
         * @return {?}
         */
        function () {
            return build(this._template, this._stylesObj, this._attrsObj, this._classes);
        };
        return Wrapper;
    }());
    if (false) {
        /**
         * @type {?}
         * @private
         */
        Wrapper.prototype._stylesObj;
        /**
         * @type {?}
         * @private
         */
        Wrapper.prototype._attrsObj;
        /**
         * @type {?}
         * @private
         */
        Wrapper.prototype._classes;
        /**
         * @type {?}
         * @private
         */
        Wrapper.prototype._flexDefaults;
        /** @type {?} */
        Wrapper.prototype.withStyles;
        /** @type {?} */
        Wrapper.prototype.withAttrs;
        /** @type {?} */
        Wrapper.prototype.withWidth;
        /** @type {?} */
        Wrapper.prototype.withHeight;
        /** @type {?} */
        Wrapper.prototype.withMaxWidth;
        /** @type {?} */
        Wrapper.prototype.withMaxHeight;
        /** @type {?} */
        Wrapper.prototype.withFlex;
        /**
         * @type {?}
         * @private
         */
        Wrapper.prototype._template;
    }
    /** @type {?} */
    var wrapper = (/**
     * @param {?} template
     * @return {?}
     */
    function (template) { return new Wrapper(template); });

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     */
    var FlexComponent = /** @class */ (function () {
        function FlexComponent() {
            this._classes = "component";
            this.destroySubject = new rxjs.Subject();
            this.destroy = this.destroySubject.asObservable();
            this.flex = true;
            this.fix = true;
            this.alignment = "stretch";
            this.justification = "flex-start";
            this.direction = "column";
            this.wrap = "nowrap";
            this.additionClasses = [];
        }
        Object.defineProperty(FlexComponent.prototype, "classes", {
            get: /**
             * @return {?}
             */
            function () {
                return this._classes;
            },
            set: /**
             * @param {?} v
             * @return {?}
             */
            function (v) {
                this._classes = "component " + v + " " + this.additionClasses.join(" ");
            },
            enumerable: true,
            configurable: true
        });
        // tslint:disable-next-line: use-life-cycle-interface
        // tslint:disable-next-line: use-life-cycle-interface
        /**
         * @return {?}
         */
        FlexComponent.prototype.ngOnDestroy = 
        // tslint:disable-next-line: use-life-cycle-interface
        /**
         * @return {?}
         */
        function () {
            this.destroySubject.next();
            this.destroySubject.complete();
            if (FlexComponent.LOGS === "verbose") {
                console.log("FlexComponent destroyed", this.destroySubject);
            }
        };
        FlexComponent.LOGS = "verbose";
        return FlexComponent;
    }());
    if (false) {
        /** @type {?} */
        FlexComponent.LOGS;
        /** @type {?} */
        FlexComponent.prototype.flex;
        /** @type {?} */
        FlexComponent.prototype.alignment;
        /** @type {?} */
        FlexComponent.prototype.selfAlignment;
        /** @type {?} */
        FlexComponent.prototype.justification;
        /** @type {?} */
        FlexComponent.prototype.direction;
        /** @type {?} */
        FlexComponent.prototype.fix;
        /** @type {?} */
        FlexComponent.prototype.wrap;
        /** @type {?} */
        FlexComponent.prototype.additionClasses;
        /**
         * @type {?}
         * @private
         */
        FlexComponent.prototype._classes;
        /**
         * @type {?}
         * @private
         */
        FlexComponent.prototype.destroySubject;
        /**
         * @type {?}
         * @protected
         */
        FlexComponent.prototype.destroy;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    if (!window["#flex-component.version"]) {
        window["#flex-component.version"] = "2.3.3";
    }
    /** @type {?} */
    var PACKAGE_VERSION = "2.3.1";

    exports.FlexComponent = FlexComponent;
    exports.FromRouteData = FromRouteData;
    exports.MapParams = MapParams;
    exports.MapQueryParams = MapQueryParams;
    exports.MapRouteParams = MapRouteParams;
    exports.PACKAGE_VERSION = PACKAGE_VERSION;
    exports.Wrapper = Wrapper;
    exports.wrapper = wrapper;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dev-stream-angular-utils.umd.js.map
